//=============================================================================
// WeaponPlasmaRifle.
//=============================================================================
class ANNAWeaponPlasmaRifle extends ANNAWeapon;

function int GetWeaponDamageSkill(int userLevel, optional actor target) //plasma was slightly buffed
{
	//now 1 burst of plasma instead of 3, so do vanilla damage * 3 to find old values
	
	if(userLevel == 0) //untrained (sp-only?)
		return 24;
	if(userLevel == 1) //trained
		return 35;
	if(userLevel == 2) //advanced
		return 37;
	if(userLevel == 3) //master
		return 46;
	if(userLevel == 4) //master + targ
		return 52;
}

simulated function float GetWeaponRecoilSkill(float userLevel)
{
	//these default values are just an EXAMPLE. Please override them!
	
	if(userLevel == 0) //untrained (sp-only?)
		return 1;
	if(userLevel == 1) //trained
		return 0.6;
	if(userLevel == 2) //advanced
		return 0.3;
	if(userLevel == 3) //master
		return 0;
	if(userLevel == 4) //master + targ
		return 0;
}

defaultproperties
{
	bringUpTime=1
	numShots=1
	gunAccuracy=0.19
	bInstantHit=false
	shotTime=0.7
     LowAmmoWaterMark=12
     GoverningSkill=Class'DeusEx.SkillWeaponHeavy'
     EnviroEffective=ENVEFF_AirVacuum
     reloadTime=2.000000
     HitDamage=35
     maxRange=24000
     AccurateRange=14400
     BaseAccuracy=0.600000
     bCanHaveScope=True
     ScopeFOV=20
     bCanHaveLaser=True
     AreaOfEffect=AOE_Cone
     bPenetrating=False
     recoilStrength=0.300000
     mpReloadTime=0.500000
     mpHitDamage=20
     mpBaseAccuracy=0.500000
     mpAccurateRange=8000
     mpMaxRange=8000
     mpReloadCount=12
     bCanHaveModBaseAccuracy=True
     bCanHaveModReloadCount=True
     bCanHaveModAccurateRange=True
     bCanHaveModReloadTime=True
     bCanHaveModRecoilStrength=True
     AmmoName=Class'DeusEx.AmmoPlasma'
     ReloadCount=12
     PickupAmmoCount=12
     ProjectileClass=Class'DeusEx.PlasmaBolt'
     shakemag=50.000000
     FireSound=Sound'DeusExSounds.Weapons.PlasmaRifleFire'
     AltFireSound=Sound'DeusExSounds.Weapons.PlasmaRifleReloadEnd'
     CockingSound=Sound'DeusExSounds.Weapons.PlasmaRifleReload'
     SelectSound=Sound'DeusExSounds.Weapons.PlasmaRifleSelect'
     InventoryGroup=8
     ItemName="Plasma Rifle"
     PlayerViewOffset=(X=18.000000,Z=-7.000000)
     PlayerViewMesh=LodMesh'DeusExItems.PlasmaRifle'
     PickupViewMesh=LodMesh'DeusExItems.PlasmaRiflePickup'
     ThirdPersonMesh=LodMesh'DeusExItems.PlasmaRifle3rd'
     LandSound=Sound'DeusExSounds.Generic.DropLargeWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconPlasmaRifle'
     largeIcon=Texture'DeusExUI.Icons.LargeIconPlasmaRifle'
     largeIconWidth=203
     largeIconHeight=66
     invSlotsX=4
     invSlotsY=2
     Description="An experimental weapon that is currently being produced as a series of one-off prototypes, the plasma gun superheats slugs of magnetically-doped plastic and accelerates the resulting gas-liquid mix using an array of linear magnets. The resulting plasma stream is deadly when used against slow-moving targets."
     beltDescription="PLASMA"
     Mesh=LodMesh'DeusExItems.PlasmaRiflePickup'
     CollisionRadius=15.600000
     CollisionHeight=5.200000
     Mass=50.000000
}
